////////////////////////////////////////////////////////////////////
//
//		CLASS : loadThread 
//		===================
//    this thread is used for reading machine load information from
//    the Resource table in VDCE Repository.
////////////////////////////////////////////////////////////////////

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;

class loadThread implements Runnable {

    boolean die = false;
    private TextArea data;
    private String urlstr;
    Thread lthread = null;
    private loadInfoWin lwin = null;
    
    public loadThread(loadInfoWin lwin, TextArea data, String urlstr) {

	this.data = data;
	this.urlstr = urlstr;
	this.lwin = lwin;
     }

    public void start() {

	if (lthread == null)
	    lthread = new Thread(this);
	if (lthread.isAlive())
	    lthread.resume();
	else
	    lthread.start();
     }

    public void stop() {

	if (lthread != null) {
	    lthread.stop();
	    lthread = null;
	 }
     }

    private String make_spaces(int num) {
	String spaces = "";
	if (num > 0) 
	for (int i = 0; i < num; i ++)
	     spaces += " ";
	return spaces;
     }

    public void run() {

	DataInputStream datas = null;
	int pos = 0;
        URL url = null;
        String titleStr = "____________________________________________________________________________\n";
        data.insertText(titleStr, pos);
        pos += titleStr.length();
        titleStr = "   MACHINE_NAME      OS_NAME    LOAD      PROCESS    TOTAL_MEM    FREE_MEM \n";
        data.insertText(titleStr, pos);
        pos += titleStr.length();
        titleStr = "----------------------------------------------------------------------------\n";
        data.insertText(titleStr, pos);

        pos += titleStr.length();
	int run_pos;
	String aline = null;
	while (true) {
	     if (die)
		 break;
	     if (lwin.pos > 0)
	         data.replaceText("  ", pos, lwin.pos);
	     run_pos = pos;
             try {
                 url = new URL(urlstr);
              }  catch (MalformedURLException e)
                    { System.out.println("Error in requesting loadInfoServ servlet"); }
            
             try {
                 datas = new DataInputStream(url.openStream());
              }  catch (IOException e)
                    { System.out.println("Error in opening data stream of loadInfoServ");}
             try {
		 String mach_name, domain_name, cluster_name, os_name;
		 String load, proc_num, total_mem, avail_mem;
		 int index;
                 while ((aline = datas.readLine()) != null) {
			index = aline.indexOf(" ");
			mach_name = aline.substring(0, index);
			mach_name += make_spaces(12-mach_name.length());
		    	aline = aline.substring(index+1, aline.length());
			index = aline.indexOf(" ");

/*			domain_name = aline.substring(0, index);
			domain_name += make_spaces(5 - domain_name.length());
		    	aline = aline.substring(index+1, aline.length());
			index = aline.indexOf(" ");
			cluster_name = aline.substring(0, index);
			cluster_name += make_spaces(6 - cluster_name.length());
		    	aline = aline.substring(index+1, aline.length());
			index = aline.indexOf(" ");
use this part until the Resource table modified  --- Aug. 21
*/
			load = aline.substring(0, index);
			load += make_spaces(4-load.length());
		    	aline = aline.substring(index+1, aline.length());
			index = aline.indexOf(" ");
			os_name = aline.substring(0, index);
			os_name += make_spaces(6-os_name.length());
		    	aline = aline.substring(index+1, aline.length());
			index = aline.indexOf(" ");
			proc_num = aline.substring(0, index);
			proc_num += make_spaces(6 - proc_num.length());
		    	aline = aline.substring(index+1, aline.length());
			index = aline.indexOf(" ");
			total_mem = aline.substring(0, index);
			total_mem += make_spaces(8 -total_mem.length());
		    	avail_mem = aline.substring(index+1, aline.length());
			avail_mem += make_spaces(8 -avail_mem.length());
/*			aline = " " + mach_name + "| " + make_spaces(5) + "| " 
			      + make_spaces(6) + "| " + os_name 
			      + "| " + load + " | " + proc_num + "| " 
			      + total_mem + "| " + avail_mem + "\n";
*/
			aline = "     " + mach_name + "  |  " + os_name 
			      + "  |  " + load + "   |  " + proc_num + "  |  " 
			      + total_mem + "  |  " + avail_mem + "\n";
			data.insertText(aline, run_pos);
                        run_pos += aline.length();
                   }
                 datas.close();
		 lwin.pos = run_pos;
              }  catch (IOException e)
                    { System.out.println("Error in reading load info "); }
	     try {
               	 Thread.sleep(60000);
              }  catch (InterruptedException e) { }
//	     g.setFont(original);
	 }
    }
}
